#!c:/perl/bin/perl

##############################################################################
# MTVWebdesign Logness                        Version 1.0
# arch.cgi: The main script
# Copyright 1999-2000 Maarten Veerman mtveerman@mindless.com
# MTVWebdesign:    http://mtvwebdesign.hypermart.net/ (http://mtvwebdesign.hypermart.net/scripts/)
##############################################################################
# COPYRIGHT NOTICE
# Copyright 1999-2000 Maarten Veerman  All Rights Reserved.
#
# LogNess may be used and modified so long as this
# copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Maarten Veerman from any liability that
# might arise from its use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program in any way.
#
# Obtain permission before redistributing this software over the Internet or
# in any other medium. In all cases copyright and header must remain intact
#
# Please send bug-reports to cgi-bugs@mtvwebdesign.hypermart.net
##############################################################################
#
# Script tested locally:
# Pentium 400Mhz, 128MB RAM, Windows 98, Apache 1.3.4 (win32), Perl, MS Internet Explorer 5.0, Netscape 4.05.
#
##############################################################################
# Please do not remove the following lines:
$scriptname = "LogNess";
$version = "1.0";
##############################################################################

CONFIG:{
	use CGI::Carp qw(fatalsToBrowser);
	require 'logness.conf';
	require $mtvwebdesignlib;
	require $hosts;
	require $dbunderpath;
	$dbdir = &dbdir_;
	require $dbunder;
}

MAIN:{
	&getinput;
	&GetCookies;

	$script_location = $ENV{'SCRIPT_NAME'};
	
	if (!$Cookies{'loggedin'} && $FORM{'action'} ne "login") {
		&login;
	}
	
	if ($FORM{'action'} eq "login") {
		&check_login;
	}
	elsif ($FORM{'action'} eq "logout") {
		&logout;
	}
	elsif ($FORM{'action'} eq "cp") {
		&cp;
	}
	elsif ($FORM{'action'} eq "cpn") {
		&cpn;
	}
	else {
		&mainpage;
	}
	
	exit;
}

sub login {
	local($warn) = @_;
	print "Content-type: text/html\n\n";
	&pageheader("Login page for $servicename");
	foreach $line (@temptoken) {
		if ($line =~ m/$token/i) {
			print qq~
			<h2>Login</h2>
			~;
			&warn($warn);
			print qq~
			<form action="$ENV{'SCRIPT_NAME'}" method="post">
			<input type="hidden" name="action" value="login">
			<input type="hidden" name="id" value="$id">
			Please enter your password: <input type="password" name="password"> <input type="submit">
			</form>
			~;
		}
		print "$line";
	}
	&powered_by("nologout");
	exit;
}

sub check_login {
	if ($enc_pass) { $FORM{'password'} = crypt($FORM{'password'}, Mv); }
	&login("The password you entered was not correct") if (lc $FORM{'password'} ne lc $webmasterpass);
	&SetCookies("loggedin", "1");
	&mainpage;
	#$day = &GetTableName("day");
	#$month = &GetTableName("month");
	&SetCookies("daytable","0","monthtable","0");
}

sub mainpage {
	
	if ($FORM{'table'}) {
		$FORM{'table'} =~ s/a//i;
		&SetCookies("daytable","$FORM{'table'}");
		$Cookies{'daytable'} = $FORM{'table'};
	}
	if ($FORM{'month'}) {
		$FORM{'month'} =~ s/a//i;
		&SetCookies("monthtable","$FORM{'month'}");
		$Cookies{'monthtable'} = $FORM{'month'};
	}
	
	print "Content-type: text/html\n\n";
	&pageheader("View statistics");
	foreach $line (@temptoken) {
		if ($line =~ m/$token/i) {
			print qq~
			<h2>View your statistics</h2>
			~;
			if (!$enc_pass) {
				&warn("Please note that your password is not encrypted. Please <a href=\"$ENV{'SCRIPT_NAME'}?action=cp\">click here</a> to change your password!")
			}
			&bar;
			print qq~
			<hr noshade>
			<center>
			~;
			
			if ($FORM{'see'}) {
				$sub = $FORM{'see'};
				&$sub;
			}
			
			print qq~
			</center>
			~;
		}
		print "$line";
	}
	&powered_by;
	exit;
}

sub bar {
	print qq~
	<script>
	<!--
	function goLogNessa(){
		if (document.logness.a.options[document.logness.a.selectedIndex].value == "") {
			window.alert ("Please select an option");
		}
		else {
			var URL = document.logness.a.options[document.logness.a.selectedIndex].value;
			window.location.href = URL;
		}
	}
	function goLogNessb(){
		if (document.logness.b.options[document.logness.b.selectedIndex].value == "") {
			window.alert ("Please select an option");
		}
		else {
			var URL = document.logness.b.options[document.logness.b.selectedIndex].value;
			window.location.href = URL;
		}
	}
	function goLogNessc(){
		if (document.logness.c.options[document.logness.c.selectedIndex].value == "") {
			window.alert ("Please select an option");
		}
		else {
			var URL = document.logness.c.options[document.logness.c.selectedIndex].value;
			window.location.href = URL;
		}
	}
	function goLogNessd(){
		if (document.logness.d.options[document.logness.d.selectedIndex].value == "") {
			window.alert ("Please select an option");
		}
		else {
			var URL = document.logness.d.options[document.logness.d.selectedIndex].value;
			window.location.href = URL;
		}
	}
	function goLogNesse(){
		if (document.logness2.e.options[document.logness2.e.selectedIndex].value == "") {
			window.alert ("Please select an option");
		}
		else {
			var URL = document.logness2.e.options[document.logness2.e.selectedIndex].value;
			window.location.href = URL;
		}
	}
	// -->
	</script>
	<form name="logness">
	<table cellpadding="3" cellspacing="0" border="1" width="75%" align="center">
	<tr><td colspan="2">Please select the day you want to see statistics for:
	<select name="a" onChange="goLogNessa();">
	~;
	
	for ($i=0;$i<= $num_days_log;$i++) {
		$day = &GetDates("day","$i");
		$table = &GetTableName("day","$i");
		$cookietable = &GetTableName("day","$Cookies{'daytable'}");
		if ($table eq $cookietable) {
			$selected = " selected";
		}
		print qq~<option value="$ENV{'SCRIPT_NAME'}?table=a$i&see=$FORM{'see'}&id=$id"$selected>$day\n~;
		undef $selected;
	}
	
	print qq~
	</select>
	</td><td align="right"><font size="1"><a href="$ENV{'SCRIPT_NAME'}?action=cp">Change your password</a></font></td></tr>
	<tr><td align="center">Traffic<br><select name="b" onChange="goLogNessb();">
	<option value="">--Select--
	<option value="$ENV{'SCRIPT_NAME'}?see=phbd&id=$id">Page Hits by Day
	<option value="$ENV{'SCRIPT_NAME'}?see=vbd&id=$id">Visitors by Day
	<option value="$ENV{'SCRIPT_NAME'}?see=phbp&id=$id">Page Hits by Page
	<option value="$ENV{'SCRIPT_NAME'}?see=phbm&id=$id">Page Hits by Month
	<option value="$ENV{'SCRIPT_NAME'}?see=vbm&id=$id">Visitors by Month
	</select></td>
	<td align="center">Visitor Profile<br><select name="c" onChange="goLogNessc();">
	<option value="url">--Select--
	<option value="$ENV{'SCRIPT_NAME'}?see=b&id=$id">Browsers
	<option value="$ENV{'SCRIPT_NAME'}?see=os&id=$id">Operating Systems
	<option value="$ENV{'SCRIPT_NAME'}?see=mcd&id=$id">Monitor Color Depths
	<option value="$ENV{'SCRIPT_NAME'}?see=mr&id=$id">Monitor Resolutions
	<option value="$ENV{'SCRIPT_NAME'}?see=l&id=$id">Languages
	<option value="$ENV{'SCRIPT_NAME'}?see=j&id=$id">Javascript
	<option value="$ENV{'SCRIPT_NAME'}?see=c&id=$id">Cookies
	<option value="$ENV{'SCRIPT_NAME'}?see=ip&id=$id">IP addresses
	</select></td>
	<td align="center">Marketing Reports<br><select name="d" onChange="goLogNessd();">
	<option value="url">--Select--
	<option value="$ENV{'SCRIPT_NAME'}?see=r&id=$id">Referers
	<option value="$ENV{'SCRIPT_NAME'}?see=se&id=$id">Search Engines
	<option value="$ENV{'SCRIPT_NAME'}?see=mh&id=$id">Mail Hosts
	</select></td></tr>
	</table>
	</form>
	~;
}

sub cp {
	# Change webmaster password
	
	print "Content-type: text/html\n";
	&expires_header("now");
	print "\n";
	&pageheader("Change webmaster password");
	foreach $line (@temptoken) {
		if ($line =~ m/$token/i) {
			print qq~
			<h2>Change webmaster password</h2>
			Please fill out the form below and press the submit button.
			<form action="$ENV{'SCRIPT_NAME'}" method="post">
			<input type="hidden" name="action" value="cpn">
			<input type="hidden" name="id" value="$id">
			<table cellpadding="5" cellspacing="0" border="1">
			<tr><td>Please enter your old password:</td><td><input type="password" name="oldpass"></td></tr>
			<tr><td>Please enter your new password:</td><td><input type="password" name="newpass1"></td></tr>
			<tr><td>Please enter your new password again:</td><td><input type="password" name="newpass2"></td></tr>
			<tr><td colspan="2" align="center">Please check this box if you want to encrypt your password (We strongly advice this!): <input type="checkbox" name="crypt" CHECKED></td></tr>
			<tr><td colspan="2" align="center"><input type="submit"></td></tr>
			</table>
			</form>
			~;
		}
		print "$line";
	}
	&powered_by;
	
}

sub cpn {
	# Change webmasterpassword now
	
	if ($enc_pass) { $FORM{'oldpass'} = crypt($FORM{'oldpass'}, Mv); }
	&errors("oldpass") if ($FORM{'oldpass'} ne $webmasterpass);
	&errors("newpass") if ($FORM{'newpass1'} ne $FORM{'newpass2'} || !$FORM{'newpass1'});
	
	if ($FORM{'crypt'}) { $FORM{'newpass1'} = crypt($FORM{'newpass1'}, Mv); }
	
	
	open(SETUP, "+<$config_file") || die "Cannot open $config_file";
	flock(SETUP, 2) if $use_flock;
	
	# Seek the beginning of the file.
	seek (SETUP, 0, 0);
	# Now place all the lines in an array....
	@lines = <SETUP>;
	
	# Seek the beginning of the file again.....
	seek (SETUP, 0, 0);
	# ....and empty the file.....
	truncate (SETUP, 0);
	
	foreach $line (@lines) {
		if ($line =~ /\$webmasterpass\s*=\s*["\'][^"\']+["\']\;/) {
			print SETUP "\$webmasterpass = \"$FORM{newpass1}\"\;\n";
			if ($FORM{'crypt'}) {
				print SETUP "\$enc_pass = \"1\"\;\n";
			}
		}
		elsif ($line =~ /\$enc_pass\s*=\s*["\'][^"\']+["\']\;/) {
			print SETUP "";
		}
		else {
			print SETUP "$line";
		}
	}
	flock(SETUP, 8) if $use_flock;
	close(SETUP);
	
	print "Content-type: text/html\n\n";
	&pageheader("Password changed");
	foreach $line (@temptoken) {
		if ($line =~ m/$token/i) {
			print qq~
			<h1>Password changed</h1>
			Your webmaster password was succesfully changed! Please <a href="$ENV{'SCRIPT_NAME'}?$id">click here</a> to go back to the mainpage!
			~;
		}
		print "$line";
	}
	&powered_by;
	exit;
}


sub GetTableName {
	# Returns the table name, either a day or a month
	
	local($what,$when) = @_;
	
	my($time, $table);
	
	my(@MON)=qw/Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec/;
	my(@WDAY) = qw/Sun Mon Tue Wed Thu Fri Sat/;
	
	if ($when) {
		if ($what eq "day") {
			$when = $when * 24 * 60 * 60;
		}
		elsif ($what eq "month") {
			$when = $when * 31 * 24 * 60 * 60;
		}
		else {
			$table = "Please specify day or month";
			die "$table";
		}
	}
	else {
		$when = 0;
	}
	
	$time = time - $when;
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
	$year += 1900;
	
	if ($what eq "day") {
		$table = $WDAY[$wday] . $mday . $MON[$mon] . $year;
		return $table;
	}
	elsif ($what eq "month") {
		$table = $MON[$mon] . $year;
		return $table;
	}
	else {
		$table = "Please specify day or month";
		die "$table";
	}
}

sub GetDates {
	# Works like the sub above
	
	local($what,$when) = @_;
	
	my($time, $table);
	
	my(@MON)=qw/Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec/;
	my(@WDAY) = qw/Sun Mon Tue Wed Thu Fri Sat/;
	
	if ($when ne "0") {
		if ($what eq "day") {
			$when = $when * 24 * 60 * 60;
		}
		elsif ($what eq "month") {
			$when = $when * 31 * 24 * 60 * 60;
		}
		else {
			$table = "Please specify day or month";
			die "$table";
		}
	}
	else {
		$when = 0;
	}
	
	$time = time - $when;
	my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
	$year += 1900;
	
	if ($what eq "day") {
		$table = $WDAY[$wday] . " " . $mday . ", " . $MON[$mon];
		return $table;
	}
	elsif ($what eq "month") {
		$table = $MON[$mon] . " " . $year;
		return $table;
	}
	else {
		$table = "Please specify day or month";
		die "$table";
	}
}

sub warn {
	local($warn) = @_;
	if ($warn) {
		print qq~<font color="#FF0000"><b>$warn</b></font><p>~;
	}
}

sub opendb {
	&LockAndOpen_("","LogNess");
	&CreateDatabase_;
}

sub closedb {
	&UnlockAndCommit_;
}

sub phbd {
	&opendb;
	$daytable = &GetTableName("day","$Cookies{'daytable'}");
	@today = &SelectFromTable_("$daytable","AND","hour");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@yesterday = &SelectFromTable_("$table","AND","hour");
	&closedb;
	
	$tod = scalar @today;
	$yes = scalar @yesterday;
	$tod--;
	$yes--;
	
	$max=0;
	for($x=1;$x < scalar @today;$x++) {
		if ($todayhours{$today[$x]}) {
			$num = $todayhours{$today[$x]};
			$num++;
			$todayhours{$today[$x]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$todayhours{$today[$x]} = "1";
		}
		undef $num;
	}
	
	for($x=1;$x < scalar @yesterday;$x++) {
		if ($yesterdayhours{$yesterday[$x]}) {
			$num = $yesterdayhours{$yesterday[$x]};
			$num++;
			$yesterdayhours{$yesterday[$x]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$yesterdayhours{$yesterday[$x]} = "1";
		}
		undef $num;
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Page Hits By day</h3>
	<center>
	<table cellpadding="4" cellspacing="8" border="0">
	<tr><Td>Yesterday: <img src="$pixel_a" width="25" height="5"> <font size="-1"><b>(total: $yes)</b></font></tD><td>Today: <img src="$pixel_b" width="25" height="5"> <font size="-1"><b>(total: $tod)</b></font></td></tr>
	</table>
	</center>
	<table>
	<tr><td><font size="1">$max</font></td></tr>
	~;
	
	# Graphic: max is 200
	print qq~<tr><td align="right"><img src="$border_pix" width="1" height="200"></td>~;
	for($h=0;$h < 24;$h++) {
		$yesterdayhours{$h} = $yesterdayhours{$h} || "0";
		$todayhours{$h} = $todayhours{$h} || "0";
		
		$p = 200 / $max;
		$yheight = $yesterdayhours{$h} * $p;
		$theight = $todayhours{$h} * $p;
		
		print qq~<td valign="bottom"><img src="$pixel_a" width="5" height="$yheight" alt="" border="0"><img src="$pixel_b" width="5" height="$theight" alt="" border="0"></td>\n~;
	}
	print qq~</tr><tr><td></td>~;
	
	
	
	
	for($h=0;$h < 24;$h++) {
		print qq~<td><font size="1">$h:00</font></td>~;
	}
	print qq~</tr></table><p>~;
	
	print qq~
	<table cellpadding="2" cellspacing="0" border="1" align="center">
	<tr><td><b>Hour</b></td><td><b>Yesterday</b></td><td><b>Today</b></td><td>&nbsp;</td></tr>
	~;
	
	for($h=0;$h < 24;$h++) {
		$yesterdayhours{$h} = $yesterdayhours{$h} || "0";
		$todayhours{$h} = $todayhours{$h} || "0";
		
		if ($todayhours{$h} > $yesterdayhours{$h}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		print qq~<tr><td>$h:00</td><td align="center">$yesterdayhours{$h}</td><td align="center">$todayhours{$h}</td><td><img src="$ud"></tr>\n~;
	}
	
	print qq~
	</table>
	~;
	
}
sub vbd {
	&opendb;
	$daytable = &GetTableName("day","$Cookies{'daytable'}");
	@today = &SelectFromTable_("$daytable","AND","hour","rv|ne|1");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@yesterday = &SelectFromTable_("$table","AND","hour","rv|ne|1");
	&closedb;
	
	$tod = scalar @today;
	$yes = scalar @yesterday;
	$tod--;
	$yes--;
	
	$max=0;
	for($x=1;$x < scalar @today;$x++) {
		if ($todayhours{$today[$x]}) {
			$num = $todayhours{$today[$x]};
			$num++;
			$todayhours{$today[$x]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$todayhours{$today[$x]} = "1";
		}
		undef $num;
	}
	
	for($x=1;$x < scalar @yesterday;$x++) {
		if ($yesterdayhours{$yesterday[$x]}) {
			$num = $yesterdayhours{$yesterday[$x]};
			$num++;
			$yesterdayhours{$yesterday[$x]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$yesterdayhours{$yesterday[$x]} = "1";
		}
		undef $num;
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Visitors By Day</h3>
	<center>
	<table cellpadding="4" cellspacing="8" border="0">
	<tr><Td>Yesterday: <img src="$pixel_a" width="25" height="5"> <font size="-1"><b>(total: $yes)</b></font></tD><td>Today: <img src="$pixel_b" width="25" height="5"> <font size="-1"><b>(total: $tod)</b></font></td></tr>
	</table>
	</center>
	<table>
	<tr><td><font size="1">$max</font></td></tr>
	~;
	
	# Graphic: max is 200
	print qq~<tr><td align="right"><img src="$border_pix" width="1" height="200"></td>~;
	for($h=0;$h < 24;$h++) {
		$yesterdayhours{$h} = $yesterdayhours{$h} || "0";
		$todayhours{$h} = $todayhours{$h} || "0";
		
		$p = 200 / $max;
		$yheight = $yesterdayhours{$h} * $p;
		$theight = $todayhours{$h} * $p;
		
		print qq~<td valign="bottom"><img src="$pixel_a" width="5" height="$yheight" alt="" border="0"><img src="$pixel_b" width="5" height="$theight" alt="" border="0"></td>\n~;
	}
	print qq~</tr><tr><td></td>~;
	for($h=0;$h < 24;$h++) {
		print qq~<td><font size="1">$h:00</font></td>~;
	}
	print qq~</tr></table><p>~;
	
	print qq~
	<table cellpadding="2" cellspacing="0" border="1" align="center">
	<tr><td><b>Hour</b></td><td><b>Yesterday</b></td><td><b>Today</b></td><td>&nbsp;</td></tr>
	~;
	
	#Graphic here.
	
	for($h=0;$h < 24;$h++) {
		$yesterdayhours{$h} = $yesterdayhours{$h} || "0";
		$todayhours{$h} = $todayhours{$h} || "0";
		
		if ($todayhours{$h} > $yesterdayhours{$h}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		print qq~<tr><td>$h:00</td><td align="center">$yesterdayhours{$h}</td><td align="center">$todayhours{$h}</td><td><img src="$ud"></td></tr>\n~;
	}
	
	print qq~
	</table>
	~;
	
}
sub phbp {
	&opendb;
	$daytable = &GetTableName("day","$Cookies{'daytable'}");
	@today = &SelectFromTable_("$daytable","AND","doc");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@yesterday = &SelectFromTable_("$table","AND","doc");
	&closedb;
	
	for($x=1;$x < scalar @today;$x++) {
		if ($todaypages{$today[$x]}) {
			$num = $todaypages{$today[$x]};
			$num++;
			$todaypages{$today[$x]} = $num;
		}
		else {
			$todaypages{$today[$x]} = "1";
		}
		undef $num;
	}
	
	for($x=1;$x < scalar @yesterday;$x++) {
		if ($yesterdaypages{$yesterday[$x]}) {
			$num = $yesterdaypages{$yesterday[$x]};
			$num++;
			$yesterdaypages{$yesterday[$x]} = $num;
		}
		else {
			$yesterdaypages{$yesterday[$x]} = "1";
		}
		undef $num;
	}
	
	print qq~
	<h3>Page Hits By Page</h3>
	<table cellpadding="2" cellspacing="0" border="1" align="center">
	<tr><td><b>Page</b></td><td><b>Yesterday</b></td><td><b>Today</b></td><td>&nbsp;</td></tr>
	~;
	
	foreach $page (sort { $todaypages{$b} <=> $todaypages{$a} } %todaypages) {
		if ($yesterpages{$page} || $todaypages{$page}) {
			$yesterdaypages{$page} = $yesterdaypages{$page} || "0";
			$todaypages{$page} = $todaypages{$page} || "0";
			
			if ($todaypages{$page} > $yesterdaypages{$page}) {
				$ud = $up;
			}
			else {
				$ud = $down;
			}
			
			print qq~<tr><td><a href="$page">$page</a></td><td align="center">$yesterdaypages{$page}</td><td align="center">$todaypages{$page}</td><td><img src="$ud"></td></tr>\n~;
		}
	}
	
	print qq~
	</table>
	~;
	
}
sub phbm {
	# Page Hist By Month
	&opendb;
	$monthtable = &GetTableName("month","$Cookies{'monthtable'}");
	@thismonth = &SelectFromTable_("$monthtable","AND","day,hits");
	$month = $Cookies{'monthtable'};
	$month++;
	$table = &GetTableName("month","$month");
	@lastmonth = &SelectFromTable_("$table","AND","day,hits");
	&closedb;
	
	$max=0;
	for($q=1;$q < scalar @thismonth;$q++) {
		($day, $hits) = split(/\/,$thismonth[$q]);
		$thismonth{$day} = $hits;
		$total_hits_thismonth += $hits;
		if ($hits > $max) {
			$max = $hits;
		}
	}
	for($q=1;$q < scalar @lastmonth;$q++) {
		($day, $hits) = split(/\/,$lastmonth[$q]);
		$lastmonth{$day} = $hits;
		$total_hits_lastmonth += $hits;
		if ($hits > $max) {
			$max = $hits;
		}
	}
	
	print qq~
	<h3>Page Hits By Month</h3>
	Please select the month you want to see statistics for:
	<form name="logness2">
	<select name="e" onChange="goLogNesse();">
	~;
	
	for ($i=0;$i<= $num_days_log;$i++) {
		$day = &GetDates("month","$i");
		$table = &GetTableName("month","$i");
		$cookietable = &GetTableName("month","$Cookies{'monthtable'}");
		if ($table eq $cookietable) {
			$selected = " selected";
		}
		print qq~<option value="$ENV{'SCRIPT_NAME'}?month=a$i&see=$FORM{'see'}&id=$id"$selected>$day\n~;
		undef $selected;
	}
	
	print qq~
	</select>
	</form>
	<table cellpadding="4" cellspacing="8" border="0">
	<tr><Td>Last Month: <img src="$pixel_a" width="25" height="5"> <font size="-1"><b>(total: $total_hits_lastmonth)</b></font></tD><td>This Month: <img src="$pixel_b" width="25" height="5"> <font size="-1"><b>(total: $total_hits_thismonth)</b></font></td></tr>
	</table>
	<table cellpadding="2" cellspacing="0" border="0" align="center">
	<tr><td><font size="1">$max</font></td></tr>
	<tr><td align="right"><img src="$border_pix" width="1" height="200"></td>
	~;
	
	$max = $max || 1;
	
	for($i=1;$i <= 31;$i++) {
		$thismonth{$i} = $thismonth{$i} || 0;
		$lastmonth{$i} = $lastmonth{$i} || 0;
		
		$p = 200 / $max;
		
		$lheight = $p * $lastmonth{$i};
		$theight = $p * $thismonth{$i};
		
		print qq~<td valign="bottom"><img src="$pixel_a" width="5" height="$lheight"><img src="$pixel_b" width="5" height="$theight"></td>~;
	}
	print qq~</tr><tr><td></td>~;
	for($i=1;$i <= 31;$i++) {
		print qq~<td><font size="1">$i</font></td>~;
	}
	print qq~
	</tr></table><p>
	<table cellpadding="2" cellspacing="0" border="1" align="center">
	<tr><td><b>Day</b></td><td><b>Last Month</b></td><td><b>This Month</b></td><td>&nbsp;</td></tr>
	~;
	
	for($m=1;$m <= 31;$m++) {
		$lastmonth{$m} = $lastmonth{$m} || 0;
		$thismonth{$m} = $thismonth{$m} || 0;
		
		if ($thismonth{$m} > $lastmonth{$m}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		print qq~<tr><td align="center">$m</td><td align="center">$lastmonth{$m}</td><td align="center">$thismonth{$m}</td><td><img src="$ud"></td></tr>\n~;
	}
	
	print qq~
	</table>
	~;
	
}
sub vbm {
	&opendb;
	$monthtable = &GetTableName("month","$Cookies{'monthtable'}");
	@thismonth = &SelectFromTable_("$monthtable","AND","day,visitors");
	$month = $Cookies{'monthtable'};
	$month++;
	$table = &GetTableName("month","$month");
	@lastmonth = &SelectFromTable_("$table","AND","day,visitors");
	&closedb;
	
	$max=0;
	for($q=1;$q < scalar @thismonth;$q++) {
		($day, $hits) = split(/\/,$thismonth[$q]);
		$thismonth{$day} = $hits;
		$total_hits_thismonth += $hits;
		if ($hits > $max) {
			$max = $hits;
		}
	}
	for($q=1;$q < scalar @lastmonth;$q++) {
		($day, $hits) = split(/\/,$lastmonth[$q]);
		$lastmonth{$day} = $hits;
		$total_hits_lastmonth += $hits;
		if ($hits > $max) {
			$max = $hits;
		}
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Visitors By Month</h3>
	Please select the month you want to see statistics for:
	<form name="logness2">
	<select name="e" onChange="goLogNesse();">
	~;
	
	for ($i=0;$i<= $num_days_log;$i++) {
		$day = &GetDates("month","$i");
		$table = &GetTableName("month","$i");
		$cookietable = &GetTableName("month","$Cookies{'monthtable'}");
		if ($table eq $cookietable) {
			$selected = " selected";
		}
		print qq~<option value="$ENV{'SCRIPT_NAME'}?month=a$i&see=$FORM{'see'}&id=$id"$selected>$day\n~;
		undef $selected;
	}
	
	print qq~
	</select></form>
	<table cellpadding="4" cellspacing="8" border="0">
	<tr><Td>Last Month: <img src="$pixel_a" width="25" height="5"> <font size="-1"><b>(total: $total_hits_lastmonth)</b></font></tD><td>This Month: <img src="$pixel_b" width="25" height="5"> <font size="-1"><b>(total: $total_hits_thismonth)</b></font></td></tr>
	</table>
	<table cellpadding="2" cellspacing="0" border="0" align="center">
	<tr><td><font size="1">$max</font></td></tr>
	<tr><td align="right"><img src="$border_pix" width="1" height="200"></td>
	~;
	
	for($i=1;$i <= 31;$i++) {
		$thismonth{$i} = $thismonth{$i} || 0;
		$lastmonth{$i} = $lastmonth{$i} || 0;
		
		$p = 200 / $max;
		
		$lheight = $p * $lastmonth{$i};
		$theight = $p * $thismonth{$i};
		
		print qq~<td valign="bottom"><img src="$pixel_a" width="5" height="$lheight"><img src="$pixel_b" width="5" height="$theight"></td>~;
	}
	print qq~</tr><tr><td></td>~;
	for($i=1;$i <= 31;$i++) {
		print qq~<td><font size="1">$i</font></td>~;
	}
	print qq~
	</tr></table><p>
	<table cellpadding="2" cellspacing="0" border="1" align="center">
	<tr><td><b>Day</b></td><td><b>Last Month</b></td><td><b>This Month</b></td><td>&nbsp;</td></tr>
	~;
	
	for($m=1;$m <= 31;$m++) {
		$lastmonth{$m} = $lastmonth{$m} || 0;
		$thismonth{$m} = $thismonth{$m} || 0;
		
		if ($thismonth{$m} > $lastmonth{$m}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		print qq~<tr><td align="center">$m</td><td align="center">$lastmonth{$m}</td><td align="center">$thismonth{$m}</td><td><img src="$ud"></td></tr>\n~;
	}
	
	print qq~
	</table>
	~;
	
}
sub b {
	&opendb;
	$table = &GetTableName("day","$Cookies{'daytable'}");
	@t_browsers = &SelectFromTable_("$table","AND","browser");
	@realbrowsers = &SelectFromTable_("$table","AND","realbrowser");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@y_browsers = &SelectFromTable_("$table","AND","browser");
	&closedb;
	$max=0;
	
	for($i=1; $i < scalar @t_browsers;$i++) {
		$t_browsers[$i] = $t_browsers[$i] || "unknown";
		if ($tb{$t_browsers[$i]}) {
			$num = $tb{$t_browsers[$i]};
			$num++;
			$tb{$t_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$tb{$t_browsers[$i]} = "1";
		}
	}
	
	
	for($i=1; $i < scalar @y_browsers;$i++) {
		$y_browsers[$i] = $y_browsers[$i] || "unknown";
		if ($yb{$y_browsers[$i]}) {
			$num = $yb{$y_browsers[$i]};
			$num++;
			$yb{$y_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$yb{$y_browsers[$i]} = "1";
		}
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Browsers</h3>
	Today: <img src="$pixel_b" border="0" width="25" height="5">		Yesterday: <img src="$pixel_a" border="0" width="25" height="5">
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>Browser</b></td><td>&nbsp;</td><td><b>Number</b></td><td>&nbsp;</td></tr>
	~;
	
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %tb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		if ($tb{$i} > $yb{$i}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		$m = $i || "Unknown";
		print qq~
		<tr><td>$m</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$ud"></td></tr>
		~;
		delete($yb{$i});
	}
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %yb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$m = $i || "Unknown";
		
		print qq~
		<tr><td>$m</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$down"></td></tr>
		~;
	}
	
	print qq~
	</table>
	<h3>Browser Names:</h3>
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>Name</b></td><td><b>Hits</td></tr>
	~;
	
	shift @realbrowsers;
	foreach $browser (sort @realbrowsers) {
		if ($rb{$browser}) {
			$num = $rb{$browser};
			$num++;
			$rb{$browser} = $num;
		}
		else {
			$rb{$browser} = "1";
		}
	}
	
	foreach $b (sort {$rb{$b} <=> $rb{$a}} keys %rb) {
		print qq~<tr><td>$b</td><td align="center">$rb{$b}</td></tr>\n~;
	}
	
	print qq~
	</table>
	~;
	
}
sub os {
	
	&opendb;
	$table = &GetTableName("day","$Cookies{'daytable'}");
	@t_browsers = &SelectFromTable_("$table","AND","os");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@y_browsers = &SelectFromTable_("$table","AND","os");
	&closedb;
	$max=0;
	
	for($i=1; $i < scalar @t_browsers;$i++) {
		$t_browsers[$i] = $t_browsers[$i] || "unknown";
		if ($tb{$t_browsers[$i]}) {
			$num = $tb{$t_browsers[$i]};
			$num++;
			$tb{$t_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$tb{$t_browsers[$i]} = "1";
		}
	}
	
	
	for($i=1; $i < scalar @y_browsers;$i++) {
		$y_browsers[$i] = $y_browsers[$i] || "unknown";
		if ($yb{$y_browsers[$i]}) {
			$num = $yb{$y_browsers[$i]};
			$num++;
			$yb{$y_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$yb{$y_browsers[$i]} = "1";
		}
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Operating Systems</h3>
	Today: <img src="$pixel_b" border="0" width="25" height="5">		Yesterday: <img src="$pixel_a" border="0" width="25" height="5">
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>Operating System</b></td><td>&nbsp;</td><td><b>Number</b></td><td>&nbsp;</td></tr>
	~;
	
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %tb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		if ($tb{$i} > $yb{$i}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$m = $i || "Unknown";
		
		print qq~
		<tr><td>$m</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$ud"></td></tr>
		~;
		delete($yb{$i});
	}
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %yb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$m = $i || "Unknown";
		
		print qq~
		<tr><td>$m</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$down"></td></tr>
		~;
	}
	
	print qq~
	</table>
	~;
	
	
	
}
sub mcd {
	&opendb;
	$table = &GetTableName("day","$Cookies{'daytable'}");
	@t_browsers = &SelectFromTable_("$table","AND","screen");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@y_browsers = &SelectFromTable_("$table","AND","screen");
	&closedb;
	$max=0;
	
	for($i=1; $i < scalar @t_browsers;$i++) {
		$t_browsers[$i] = $t_browsers[$i] || "unknown";
		if ($tb{$t_browsers[$i]}) {
			$num = $tb{$t_browsers[$i]};
			$num++;
			$tb{$t_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$tb{$t_browsers[$i]} = "1";
		}
	}
	
	
	for($i=1; $i < scalar @y_browsers;$i++) {
		$y_browsers[$i] = $y_browsers[$i] || "unknown";
		if ($yb{$y_browsers[$i]}) {
			$num = $yb{$y_browsers[$i]};
			$num++;
			$yb{$y_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$yb{$y_browsers[$i]} = "1";
		}
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Monitor Color Depths</h3>
	Today: <img src="$pixel_b" border="0" width="25" height="5">		Yesterday: <img src="$pixel_a" border="0" width="25" height="5">
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>Depths</b></td><td>&nbsp;</td><td><b>Number</b></td><td>&nbsp;</td></tr>
	~;
	
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %tb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		if ($tb{$i} > $yb{$i}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$m = $i || "Unknown";
		
		print qq~
		<tr><td>$m</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$ud"></td></tr>
		~;
		delete($yb{$i});
	}
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %yb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$m = $i || "Unknown";
		
		print qq~
		<tr><td>$m</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$down"></td></tr>
		~;
	}
	
	print qq~
	</table>
	~;
	
	
}
sub mr {
	&opendb;
	$table = &GetTableName("day","$Cookies{'daytable'}");
	@t_browsers = &SelectFromTable_("$table","AND","pixel");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@y_browsers = &SelectFromTable_("$table","AND","pixel");
	&closedb;
	$max=0;
	
	for($i=1; $i < scalar @t_browsers;$i++) {
		$t_browsers[$i] = $t_browsers[$i] || "unknown";
		if ($tb{$t_browsers[$i]}) {
			$num = $tb{$t_browsers[$i]};
			$num++;
			$tb{$t_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$tb{$t_browsers[$i]} = "1";
		}
	}
	
	
	for($i=1; $i < scalar @y_browsers;$i++) {
		$y_browsers[$i] = $y_browsers[$i] || "unknown";
		if ($yb{$y_browsers[$i]}) {
			$num = $yb{$y_browsers[$i]};
			$num++;
			$yb{$y_browsers[$i]} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$yb{$y_browsers[$i]} = "1";
		}
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Monitor Resolutions</h3>
	Today: <img src="$pixel_b" border="0" width="25" height="5">		Yesterday: <img src="$pixel_a" border="0" width="25" height="5">
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>Resolutions</b></td><td>&nbsp;</td><td><b>Number</b></td><td>&nbsp;</td></tr>
	~;
	
	
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %tb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		if ($tb{$i} > $yb{$i}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$m = $i || "Unknown";
		
		print qq~
		<tr><td>$m-bit</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$ud"></td></tr>
		~;
		delete($yb{$i});
	}
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %yb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$m = $i || "Unknown";
		
		print qq~
		<tr><td>$m</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$down"></td></tr>
		~;
	}
	
	print qq~
	</table>
	~;
	
	
}
sub l {
	&opendb;
	$table = &GetTableName("day","$Cookies{'daytable'}");
	@t_browsers = &SelectFromTable_("$table","AND","language");
	$day = $Cookies{'daytable'};
	$day++;
	$table = &GetTableName("day","$day");
	@y_browsers = &SelectFromTable_("$table","AND","language");
	&closedb;
	$max=0;
	
	for($i=1; $i < scalar @t_browsers;$i++) {
		$t_browsers[$i] = $t_browsers[$i] || "unknown";
@parts = split(/\;|\,/,$t_browsers[$i]);
foreach $part (@parts) {
$part = uc $part;
($o,$t) = split(/-/,$part);
if (length$o != 2) {
next;
}
		if ($tb{$part}) {
			$num = $tb{$part};
			$num++;
			$tb{$part} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$tb{$part} = "1";
		}
}
	}
	
	
	for($i=1; $i < scalar @y_browsers;$i++) {
		$y_browsers[$i] = $y_browsers[$i] || "unknown";
@parts = split(/\;|\,/,$y_browsers[$i]);
foreach $part (@parts) {
$part = uc $part;
($o,$t) = split(/-/,$part);
if (length$o != 2) {
next;
}
		if ($yb{$part}) {
			$num = $yb{$part};
			$num++;
			$yb{$part} = $num;
			if ($num > $max) {
				$max = $num;
			}
		}
		else {
			$yb{$part} = "1";
		}
}
	}
	
	$max = $max || 1;
	
	print qq~
	<h3>Languages</h3>
	Today: <img src="$pixel_b" border="0" width="25" height="5">		Yesterday: <img src="$pixel_a" border="0" width="25" height="5">
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>Language</b></td><td>&nbsp;</td><td><b>Number</b></td><td>&nbsp;</td></tr>
	~;
	
	foreach $i (sort { $tb{$b} <=> $tb{$a} } keys %tb) {
		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		if ($tb{$i} > $yb{$i}) {
			$ud = $up;
		}
		else {
			$ud = $down;
		}
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$lng = uc $i || "Unknown";
		
		print qq~
		<tr><td align="center">$lng</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$ud"></td></tr>
		~;
		delete($yb{$i});
	}

	foreach $i (sort { $yb{$b} <=> $yb{$a} } keys %yb) {

		$tb{$i} = $tb{$i} || 0;
		$yb{$i} = $yb{$i} || 0;
		
		$p = 200 / $max;
		
		$yheight = $p * $yb{$i};
		$theight = $p * $tb{$i};
		
		$lng = uc $i || "Unknown";
		
		print qq~
		<tr><td align="center">$lng</td><td><img src="$pixel_b" height="10" width="$theight"><br><img src="$pixel_a" height="10" width="$yheight"></td><td align="center">$tb{$i}<br>$yb{$i}</td><td><img src="$down"></td></tr>
		~;
	}
	
	print qq~
	</table>
	~;
	
	
}
sub j {
	$table = &GetTableName("day","$Cookies{'daytable'}");
	&opendb;
	@yesjava = &SelectFromTable_("$table","AND","java","java|eq|1");
	@nojava = &SelectFromTable_("$table","AND","java","java|eq|0");
	&closedb;
	
	$num_yesjava = scalar @yesjava;
	$num_nojava = scalar @nojava;
	$num_yesjava--;
	$num_nojava--;
	$num_yesjava = $num_yesjava || 0;
	$num_nojava = $num_nojava || 0;
	
	$max = $num_yesjava + $num_nojava;
	
	$p = 75 / $max;
	$yesheight = $p * $num_yesjava;
	$noheight = $p * $num_nojava;
	
	print qq~
	<h3>Javascript</h3>
	<table cellpadding="2" cellspacing="0" border="0">
	<tr><td>$max</td></tr>
	<tr><td></td>
	<td valign="bottom"><img src="$pixel_a" width="10" height="$yesheight" border="0"></td><td valign="bottom"><img src="$pixel_b" width="10" height="$noheight" border="0"></td></tr>
	<tr><td></td><td>Yes</td><td>No</td></tr>
	</table>
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>People with support for java:</b></td><td>$num_yesjava</td></tr>
	<tr><td><b>People with no support for java:</b></td><td>$num_nojava</td></tr>
	</table>
	~;
	
}
sub c {
	$table = &GetTableName("day","$Cookies{'daytable'}");
	&opendb;
	@yescookies = &SelectFromTable_("$table","AND","cookies","cookies|eq|Y");
	@nocookies = &SelectFromTable_("$table","AND","cookies","cookies|eq|N");
	&closedb;
	
	$num_yescookies = scalar @yescookies;
	$num_nocookies = scalar @nocookies;
	$num_yescookies--;
	$num_nocookies--;
	$num_yescookies = $num_yescookies || 0;
	$num_nocookies = $num_nocookies || 0;
	
	$max = $num_yescookies + $num_nocookies;
	
	$p = 75 / $max;
	$yesheight = $p * $num_yescookies;
	$noheight = $p * $num_nocookies;
	
	print qq~
	<h3>Cookies</h3>
	<table cellpadding="2" cellspacing="0" border="0">
	<tr><td>$max</td></tr>
	<tr><td></td>
	<td valign="bottom"><img src="$pixel_a" width="10" height="$yesheight" border="0"></td><td valign="bottom"><img src="$pixel_b" width="10" height="$noheight" border="0"></td></tr>
	<tr><td></td><td>Yes</td><td>No</td></tr>
	</table>
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>People who accept cookies:</b></td><td>$num_yescookies</td></tr>
	<tr><td><b>People who do not accept cookies:</b></td><td>$num_nocookies</td></tr>
	</table>
	~;
	
}

sub ip {
	$table = &GetTableName("day","$Cookies{'daytable'}");
	&opendb;
	@addresses = &SelectDistinctFromTable_("$table","AND","IP");
	&closedb;
	print qq~
	<h3>IP addresses</h3>
	~;
	shift @addresses;
	
	print qq~
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td align="center"><b>IP Address</b></td></tr>
	~;
	
	foreach $ip (sort @addresses) {
		$ip = $ip || "Unknown";
		print qq~<tr><td align="center">$ip</td></tr>\n~;
	}
	print qq~</table>~;
	
}

sub r {
	#@foo = grep {!/^#/} @bar;    # weed out comments
	
	$table = &GetTableName("day","$Cookies{'daytable'}");
	&opendb;
	@referers = &SelectFromTable_("$table","AND","doc,referer");
	&closedb;
	
	for($i=1;$i < scalar @referers;$i++) {
		$referers[$i] = lc $referers[$i];
	}
	
	# Now we are going to weed out Search Engines and Mail Hosts
	foreach $se ( sort keys %Engines) {
		@referers = grep { !/$se/ } @referers;
	}
	
	foreach $mh ( sort keys %Mail) {
		@referers = grep { !/$mh/ } @referers;
	}
	
	print qq~
	<h3>Referers</h3>
	<b>Outside site:</b><br><font size="-1">(Search engines and Mail hosts are not in this list)</font><p>
	~;
	
	@outside = grep { !/$hostname/} @referers;
	
	for($i=1;$i < scalar @outside;$i++) {
		($doc,$referer) = split(/\/,$outside[$i]);
		if ($ref{$referer}) {
			$num = $ref{$referer};
			$num++;
			$ref{$referer} = $num;
		}
		else {
			$ref{$referer} = "1";
		}
	}
	
	print qq~
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>Referer</b></td><td align="center"><b>Number</b></td></tr>
	~;
	
	foreach $referer (sort {$ref{$b} <=> $ref{$a}} keys %ref) {
		$referer = $referer || "Other";
		print qq~<tr><td><a href="$referer">$referer</a></td><td align="center">$ref{$referer}</td></tr>\n~;
	}
	
	print qq~
	</table>
	<p>
	<b>Inside site:</b><p>
	~;
	
	@inside = grep { /$hostname/ } @referers;
	
	
	print qq~
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td><b>From page</b></td><td><b>To page</b></td><td align="center"><b>Number</b></td></tr>
	~;
	
	for ($i=0;$i < scalar @inside;$i++) {
		($doc,$referer) = split(/\/,$inside[$i]);
		$hostname =~ s#http://##ig;
		$hostname =~ s#/$##ig;
		$referer =~ s#http://$hostname##ig;
		
		$doc =~ s/\|//igs;
		$referer =~ s/\|//igs;
		
		if ($fromto{"$referer|$doc"}) {
			$num = $fromto{"$referer|$doc"};
			$num++;
			$fromto{"$referer|$doc"} = $num;
		}
		else {
			$fromto{"$referer|$doc"} = "1";
		}
		
	}
	
	foreach $fromto (sort {$fromto{$b} <=> $fromto{$a}} keys %fromto) {
		($from,$to) = split(/\|/,$fromto);
		print qq~<td><a href="$from">$from</a></td><td><a href="$to">$to</a></td><td align="center">$fromto{$fromto}</td></tr>\n~;
	}
	
	print qq~
	</table>
	~;
}

sub se {
	
	$table = &GetTableName("day","$Cookies{'daytable'}");
	&opendb;
	@referers = &SelectFromTable_("$table","AND","referer");
	&closedb;
	
	for($i=1;$i < scalar @referers;$i++) {
		$referers[$i] = lc $referers[$i];
	}
	
	foreach $se ( sort keys %Engines) {
		@ref = grep { /$se/ } @referers;
		$refnew = join "\|\|", @ref;
		$search{$se} = $refnew;
	}
	
	print qq~
	<h3>Search Engines</h3>
	~;
	
	#Get keywords
	foreach $item (sort keys %search) {
		@splitter = split(/\|\|/,$search{$item});
		
		foreach $e (@splitter) {
			@getq = split(/\|\|/,$Engines{$item});
			@searchme = split(/\?/,$e);
			
			@fval=split(/&/,$searchme[-1]);
			foreach $i (0 .. $#fval){
				($name,$val)=split (/=/,$fval[$i],2);
				$val=~tr/+/ /;
				$val=~ s/%(..)/pack("c",hex($1))/ge;
				$name=~tr/+/ /;
				$name=~ s/%(..)/pack("c",hex($1))/ge;
				
				if (lc $name eq lc $getq[1]) {
					$keywords{$item} .= $val . "<br>";
				}
				
			}
		}
	}
	
	foreach $e (sort keys %Engines) {
		($name,$q) = split(/\|\|/,$Engines{$e});
		
		$list{$name} .= $keywords{$e};
		
	}
	
	print qq~
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td align="Center"><b>Search Engine</b></td><td align="center"><b>Keywords</b></td></tr>
	~;
	
	foreach $e (sort keys %list) {
		if ($list{$e}) {
			print qq~<tr><td align="Center" valign="top">$e</td><td align="center" valign="top">$list{$e}</td></tr>~;
		}
	}
	
	print qq~
	</table>
	~;
}

sub mh {
	$table = &GetTableName("day","$Cookies{'daytable'}");
	&opendb;
	@referers = &SelectFromTable_("$table","AND","referer");
	&closedb;
	
	for($i=1;$i < scalar @referers;$i++) {
		$referers[$i] = lc $referers[$i];
	}
	
	foreach $se ( sort keys %Mail) {
		@ref = grep { /$se/ } @referers;
		$refnew = join "\|\|", @ref;
		$search{$se} = $refnew if $refnew;
	}
	
	foreach $mh (sort keys %search) {
		($name,$q) = split(/\|\|/,$Mail{$mh});
		
		if ($mailh{$name}) {
			$num = $mailh{$name};
			$num++;
			$mailh{$name} = $num;
		}
		else {
			$mailh{$name} =  "1";
		}
		
	}
	
	print qq~
	<h3>Mail Hosts</h3>
	~;
	
	print qq~
	<table cellpadding="2" cellspacing="0" border="1">
	<tr><td align="center"><b>Mail Host</b></td><td align="center"><b>Number of Users</b></td></tr>
	~;
	
	foreach $mh (sort keys %mailh) {
		print qq~<tr><td align="center">$mh</td><td align="center">$mailh{$mh}</td></tr>~;
	}
	
	print qq~
	</table>
	~;
}
